=== debian/changelog ===
libcm256cc (1.0.5-1) unstable; urgency=medium

  * Initial release.

 -- Christoph Berg <myon@debian.org>  Sat, 15 Feb 2020 23:22:09 +0100
