=== debian/control ===
Source: libcm256cc
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 12),
 libboost-dev,
Standards-Version: 4.5.0
Homepage: https://github.com/f4exb/cm256cc
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libcm256cc
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libcm256cc.git

Package: libcm256cc1
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fast GF(256) Cauchy MDS Block Erasure Codec in C++
 cm256cc is a simple library for erasure codes. From given data it generates
 redundant data that can be used to recover the originals.

Package: libcm256cc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libcm256cc1 (= ${binary:Version}),
 ${misc:Depends},
Description: Fast GF(256) Cauchy MDS Block Erasure Codec in C++ (headers)
 cm256cc is a simple library for erasure codes. From given data it generates
 redundant data that can be used to recover the originals.
 .
 This package contains the header files.
