=== debian/watch ===
version=4
https://github.com/f4exb/cm256cc/releases .*/v(.*).tar.gz
