=== debian/changelog ===
libcm256cc (1.1.0-4.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:55:29 +0000

libcm256cc (1.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062253

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 10:28:49 +0000

libcm256cc (1.1.0-4) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with GCC-13 (Closes: #1037724)

 -- tony mancill <tmancill@debian.org>  Thu, 20 Jul 2023 21:20:22 -0700

libcm256cc (1.1.0-3) unstable; urgency=medium

  * Update github watchfile.

 -- Christoph Berg <myon@debian.org>  Sat, 05 Nov 2022 16:48:27 +0100

libcm256cc (1.1.0-2) unstable; urgency=medium

  * Restrict to architectures with SSSE3/NEON support. (Closes: #987761)

 -- Christoph Berg <myon@debian.org>  Thu, 29 Apr 2021 10:40:38 +0200

libcm256cc (1.1.0-1) unstable; urgency=low

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Christoph Berg ]
  * New upstream version 1.1.0.

 -- Christoph Berg <myon@debian.org>  Sat, 24 Apr 2021 23:22:52 +0200
