=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libcm256cc
 Section: hamradio
 Priority: optional
-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
 Uploaders:
  Christoph Berg <myon@debian.org>,
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  cmake,
  debhelper-compat (= 12),
  libboost-dev,
@@ -13,9 +14,12 @@
 Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libcm256cc
 Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libcm256cc.git
 
-Package: libcm256cc1
+Package: libcm256cc1t64
+Provides: ${t64:Provides}
+Replaces: libcm256cc1
+Breaks: libcm256cc1 (<< ${source:Version})
 Section: libs
-Architecture: any
+Architecture: amd64 arm64 armhf i386 hurd-i386 kfreebsd-amd64 kfreebsd-i386 x32
 Multi-Arch: same
 Depends:
  ${misc:Depends},
@@ -26,10 +30,10 @@
 
 Package: libcm256cc-dev
 Section: libdevel
-Architecture: any
+Architecture: amd64 arm64 armhf i386 hurd-i386 kfreebsd-amd64 kfreebsd-i386 x32
 Multi-Arch: same
 Depends:
- libcm256cc1 (= ${binary:Version}),
+ libcm256cc1t64 (= ${binary:Version}),
  ${misc:Depends},
 Description: Fast GF(256) Cauchy MDS Block Erasure Codec in C++ (headers)
  cm256cc is a simple library for erasure codes. From given data it generates
