=== debian/changelog ===
libcm256cc (1.1.2-1) unstable; urgency=medium

  * New upstream version 1.1.2.
  * Works with cmake 4. (Closes: #1113129)

 -- Christoph Berg <myon@debian.org>  Wed, 15 Oct 2025 13:27:43 +0200
