=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: libcm256cc
 Section: hamradio
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
+Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
 Uploaders:
  Christoph Berg <myon@debian.org>,
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends:
  cmake,
  debhelper-compat (= 12),
  libboost-dev,
